# Contributing to C-Blosc
We want to make contributing to this project as easy and transparent as
possible.

## Our Development Process
New versions are being developed in the "master" branch,
or in their own feature branch.
When they are deemed ready for a release, they are merged back into "master"
again.

So all contributions must stage first through "master"
or their own feature branch.

## Pull Requests
We actively welcome your pull requests.

1. Fork the repo and create your branch from `master`.
2. If you've added code that should be tested, add tests.
3. If you've changed APIs, update the documentation.
4. Ensure the test suite passes.
5. Make sure your code does not issue new compiler warnings.

## Issues
We use GitHub issues to track public bugs. Please ensure your description is
clear and has sufficient instructions to be able to reproduce the issue.

## Coding Style  
* 2 spaces for indentation rather than tabs.

## License
By contributing to C-Blosc, you agree that your contributions will be licensed
under both the [LICENSE](LICENSE.txt) file of the project.
